

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>

#include "playsdkpu.h"

static const char *xpm_play[] =
{
    "18 18 3 1",
    "	c None",
    ".	c #000000000000",
    "X	c #FFFFFFFFFFFF",
    "                  ",
    "                  ",
    "                  ",
    "    .             ",
    "    ...           ",
    "    .....         ",
    "    .......       ",
    "    .........     ",
    "    ...........   ",
    "    .........     ",
    "    .......       ",
    "    .....         ",
    "    ...           ",
    "    .             ",
    "                  ",
    "                  ",
    "                  ",
    "                  "
};

static const char*  xpm_pause[] =
{
    "18 18 3 1",
    "	c None",
    ".	c #000000000000",
    "X	c #FFFFFFFFFFFF",
    "                  ",
    "                  ",
    "                  ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "    ...   ...     ",
    "                  ",
    "                  ",
    "                  ",
    "                  "
};

static const char*  xpm_stop[] =
{
    "18 18 3 1",
    "	c None",
    ".	c #000000000000",
    "X	c #FFFFFFFFFFFF",
    "                  ",
    "                  ",
    "                  ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "   ............   ",
    "                  ",
    "                  ",
    "                  ",
    "                  "
};

static const char*  xpm_space[] =
{
    "6 18 3 1",
    "	c None",
    ".	c #000000000000",
    "X	c #FFFFFFFFFFFF",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      ",
    "      "
};

static const char*  xpm_goto_start[] =
{
    "18 18 3 1",
    "	c None",
    ".	c #000000000000",
    "X	c #FFFFFFFFFFFF",
    "                  ",
    "                  ",
    " ..      .     .  ",
    " ..     ..    ..  ",
    " ..    ...   ...  ",
    " ..   ....  ....  ",
    " ..  ..... .....  ",
    " .. ............  ",
    " ...............  ",
    " .. ............  ",
    " ..  ..... .....  ",
    " ..   ....  ....  ",
    " ..    ...   ...  ",
    " ..     ..    ..  ",
    " ..      .     .  ",
    "                  ",
    "                  ",
    "                  "
};

static const char*  xpm_back[] =
{
    "18 18 3 1",
    "	c None",
    ".	c #000000000000",
    "X	c #FFFFFFFFFFFF",
    "                  ",
    "                  ",
    "        .     .   ",
    "       ..    ..   ",
    "      ...   ...   ",
    "     ....  ....   ",
    "    ..... .....   ",
    "   ............   ",
    "  .............   ",
    "   ............   ",
    "    ..... .....   ",
    "     ....  ....   ",
    "      ...   ...   ",
    "       ..    ..   ",
    "        .     .   ",
    "                  ",
    "                  ",
    "                  "
};

static const char*  xpm_forward[] =
{
    "18 18 3 1",
    "	c None",
    ".	c #000000000000",
    "X	c #FFFFFFFFFFFF",
    "                  ",
    "                  ",
    "   .     .        ",
    "   ..    ..       ",
    "   ...   ...      ",
    "   ....  ....     ",
    "   ..... .....    ",
    "   ............   ",
    "   .............  ",
    "   ............   ",
    "   ..... .....    ",
    "   ....  ....     ",
    "   ...   ...      ",
    "   ..    ..       ",
    "   .     .        ",
    "                  ",
    "                  ",
    "                  ",
};

static const char*  xpm_goto_end[] =
{
    "18 18 3 1",
    "	c None",
    ".	c #000000000000",
    "X	c #FFFFFFFFFFFF",
    "                  ",
    "                  ",
    "  .     .      .. ",
    "  ..    ..     .. ",
    "  ...   ...    .. ",
    "  ....  ....   .. ",
    "  ..... .....  .. ",
    "  ............ .. ",
    "  ............... ",
    "  ............ .. ",
    "  ..... .....  .. ",
    "  ....  ....   .. ",
    "  ...   ...    .. ",
    "  ..    ..     .. ",
    "  .     .      .. ",
    "                  ",
    "                  ",
    "                  ",
};
